#DEFINE LINKFILES
#DEFINE WIN64

#INCLUDE "windows.h"
#INCLUDE "commctrl.h"


LV__COLUMN STRUCT
  mask	     dd
  fmt	     dd
  cx	     dd
	         dd
  pszText    dq
  cchTextMax dd
  iSubItem   dd
ENDS

LV__ITEM STRUCT
  mask	     dd
  iItem      dd
  iSubItem   dd
  state      dd
  stateMask  dd
	         dd
  pszText    dq
  cchTextMax dd
  iImage     dd
  lParam     dd
  iIndent    dd
ENDS


DATA
    slv_nr      db "Nr",0
    slv_hex     db "Color",0
    slv_perc    db "%",0
    
    num1        db "1",0
    num2        db "2",0
    proc1       db "0",0
    proc2       db "100",0
    col1        db "00112233",0
    col2        db "00AABBCC",0

	ALIGN 8

    hInstance dq ?

CODE

START:
    invoke InitCommonControls
    invoke GetModuleHandle, 0
    mov    [hInstance], rax
    invoke DialogBoxParam, [hInstance], 2000, 0, ADDR DialogProc, 0


DialogProc FRAME hWin, uMsg, wParam, lParam
	LOCAL lvc:LVCOLUMN ; LV__COLUMN works
	LOCAL lvi:LVITEM   ; LV__ITEM   works



	cmp    edx, WM_INITDIALOG
    jnz    >>

		mov    D[lvc.mask], LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM
        
        mov    rax, OFFSET slv_nr
		mov    Q[lvc.pszText], rax
		mov    D[lvc.iSubItem], 0
		mov    D[lvc.cx], 23
		invoke SendDlgItemMessage, [hWin], 2011, LVM_INSERTCOLUMN, 0, ADDR lvc
        mov    rax, OFFSET slv_hex
		mov    Q[lvc.pszText], rax
		mov    D[lvc.iSubItem], 1
		mov    D[lvc.cx], 70
		invoke SendDlgItemMessage, [hWin], 2011, LVM_INSERTCOLUMN, 1, ADDR lvc
        mov    rax, OFFSET slv_perc
		mov    Q[lvc.pszText], rax
		mov    D[lvc.iSubItem], 2
		mov    D[lvc.cx], 30
		invoke SendDlgItemMessage, [hWin], 2011, LVM_INSERTCOLUMN, 2, ADDR lvc
        ;-----------------------------------------------------------------------
        mov    rax, OFFSET num1
       	mov    D[lvi.mask],    LVIF_TEXT
        mov    Q[lvi.pszText],  rax
        mov    D[lvi.iItem], 0
        mov    D[lvi.iSubItem], 0
        invoke SendDlgItemMessage, [hWin], 2011, LVM_INSERTITEM, 0, ADDR lvi
        mov    rax, OFFSET col1
       	mov    D[lvi.mask],    LVIF_TEXT
        mov    Q[lvi.pszText],  rax
        mov    D[lvi.iItem], 0
        mov    D[lvi.iSubItem], 1
        invoke SendDlgItemMessage, [hWin], 2011, LVM_SETITEM, 0, ADDR lvi
        mov    rax, OFFSET proc1
       	mov    D[lvi.mask],    LVIF_TEXT
        mov    Q[lvi.pszText],  rax
        mov    D[lvi.iItem], 0
        mov    D[lvi.iSubItem], 2
        invoke SendDlgItemMessage, [hWin], 2011, LVM_SETITEM, 0, ADDR lvi
        
        mov    rax, OFFSET num2
       	mov    D[lvi.mask],    LVIF_TEXT
        mov    Q[lvi.pszText],  rax
        mov    D[lvi.iItem], 1
        mov    D[lvi.iSubItem], 0
        invoke SendDlgItemMessage, [hWin], 2011, LVM_INSERTITEM, 0, ADDR lvi
        mov    rax, OFFSET col2
       	mov    D[lvi.mask],    LVIF_TEXT
        mov    Q[lvi.pszText],  rax
        mov    D[lvi.iItem], 1
        mov    D[lvi.iSubItem], 1
        invoke SendDlgItemMessage, [hWin], 2011, LVM_SETITEM, 0, ADDR lvi
        mov    rax, OFFSET proc2
       	mov    D[lvi.mask],    LVIF_TEXT
        mov    Q[lvi.pszText],  rax
        mov    D[lvi.iItem], 1
        mov    D[lvi.iSubItem], 2
        invoke SendDlgItemMessage, [hWin], 2011, LVM_SETITEM, 0, ADDR lvi

    :
	cmp    edx, WM_CLOSE
    jnz    >
		invoke EndDialog,   [hWin], 0
		
	:
		xor    rax, rax
		ret
	.done:
	mov    rax, 1
	ret
ENDF


